;
; #### hello.asm ####
; To assembly this, either use the zxasm.bat file:
;
; zxasm hello
;
; or... assemble with the following options:
;
; tasm -80 -b -s hello.asm hello.p
;
;==============================================
;    ZX81 assembler 'Hello World' 
;==============================================
;
;defs
#include "zx81defs.asm"
;EQUs for ROM routines
#include "zx81rom.asm"
;ZX81 char codes/how to survive without ASCII
#include "charcodes.asm"
;system variables
#include "zx81sys.asm"

;the standard REM statement that will contain our 'hex' code
#include "line1.asm"

;------------------------------------------------------------
; code starts here and gets added to the end of the REM 
;------------------------------------------------------------
start
	ld bc,bufferOne			;load the address of buffer one into BC (see the screen file "screen.asm")
	ld (D_FILE),bc			;set D_File to the location of buffer one
	ld (screenBuffer),bc	;memory to write to vector called screenBuffer (all screen writes are done based on screenBuffer + ### number of characters)
	inc bc					;increment bc by 1
	ld (DF_CC),bc			;set DF_CC to address of bugffer one plus 1
	
	ld a, $80				;load hex 80 into a - this is the character black square
	ld (screenChar),a		;save to the variable screenChar
	call fillScreen			;call the routine to fill this buffer with black squares
	
	ld bc,bufferTwo			;load the address of buffer two (see the screen file "screen.asm") into bc
	ld (screenBuffer),bc	;memory to write to vector called screenBuffer
	
	ld a, $80				;load hex 80 into a - this is the character black square
	ld (screenChar),a		;save to the variable screenChar
	call fillScreen			;call the routine to fill this buffer with black squares
	
;this code will help show the differenc between the two buffer displays	
	ld a,$07				;load a with the character for a small white dot
	ld (bufferOne+10),a		;set the current buffer (buffer two) to have this character at position 10,0 (x,y)
	
mainLoop

;the next few lines cause the contents of buffer one to be displayed	
	ld bc,bufferOne			;set the current screen to buffer one
	ld (D_FILE),bc			;set D_File to the location of buffer one
	inc bc					;increment bc by 1
	ld (DF_CC),bc			;set DF_CC to address of bugffer one plus 1
	call delay				;wait for a small amount of time
	
;the next few lines cause the contents of buffer two to be displayed - note that this will basically cause a small dot to be displayed 
	;set the current screen to buffer two	
	ld bc,bufferTwo			;set the current screen to buffer two
	ld (D_FILE),bc			;set D_File to the location of buffer two
	inc bc					;increment bc by 1
	ld (DF_CC),bc			;set DF_CC to address of bugffer one plus 1
	call delay				;wait for a small amount of time

;in reality while buffer one is being displayed buffer two will be built
;buffer two will then be displayed and not modified until buffer one is built and this repeats	
	jp mainLoop				;repeat the switching between the two buffers to make the dot flash on and off
	
	
;====================================================================================	
;Subroutines
;====================================================================================

;====================================================================================
;flood fill the screen with blank characters
fillScreen
	ld hl,(screenBuffer)
	inc hl
	ld a, 24	;24 lines
	ld (loopCount), a
fillScreen.outerLoop	
	ld b,32		;32 rows
	ld a,(screenChar)
fillScreen.innerLoop
	ld (hl),a
	inc hl
	djnz fillScreen.innerLoop
	inc hl
	ld a,(loopCount)	
	dec a
	ld (loopCount),a
	cp 0
	jr nz, fillScreen.outerLoop		
	ret

	
;====================================================================================
;delay for # number of frames	
delay
    ld   hl,FRAMES         ; fetch timer                 
    ld   a,(hl)                                          
    sub  10                ; wait 10 full frames 
delayLoop        
	cp  (hl) 
    jr   nz,delayLoop
	ret	

	
;include our variables
#include "vars.asm"

; ===========================================================
; code ends
; ===========================================================
;end the REM line and put in the RAND USR line to call our 'hex code'
#include "line2.asm"

;display file defintion
#include "screen.asm"               
						
;close out the basic program
#include "endbasic.asm"
			
			